/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2023.02.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *          
******************************************************************************/

#ifndef MC51F7424_COMMON_H__
#define MC51F7424_COMMON_H__

#include "MC51F7424.h"
#include <intrins.h> 

typedef enum {RESET = 0, SET = !RESET} flagstatus, ITstatus;

/*********** /дȨ **********/
#define __I   volatile const
#define __O   volatile
#define __IO   volatile
/* з */
typedef   signed  char       int8_t;
typedef   signed  int        int16_t;
typedef   signed  long       int32_t;
/* ޷ */
typedef unsigned  char       uint8_t;
typedef unsigned  int        uint16_t;
typedef unsigned  long       uint32_t;
typedef unsigned  char       u8;
typedef unsigned  int        u16;
typedef unsigned  long       u32;
typedef unsigned  char       uchar;
typedef unsigned  int        uint;

#define DEF_SET_BIT0         0x01
#define DEF_SET_BIT1         0x02
#define DEF_SET_BIT2         0x04
#define DEF_SET_BIT3         0x08
#define DEF_SET_BIT4         0x10
#define DEF_SET_BIT5         0x20
#define DEF_SET_BIT6         0x40
#define DEF_SET_BIT7         0x80

#define DEF_CLR_BIT0         0xFE
#define DEF_CLR_BIT1         0xFD
#define DEF_CLR_BIT2         0xFB
#define DEF_CLR_BIT3         0xF7
#define DEF_CLR_BIT4         0xEF
#define DEF_CLR_BIT5         0xDF
#define DEF_CLR_BIT6         0xBF
#define DEF_CLR_BIT7         0x7F

#define ENABLE               1
#define DISABLE              0

#define FAIL                 1
#define PASS                 0

#define HIGH                 1
#define LOW                  0

#define ON                   1
#define OFF                  0

#define TRUE                 1
#define FALSE                0


#define NOP1()  _nop_()
#define NOP2()  NOP1(),NOP1()
#define NOP3()  NOP2(),NOP1()
#define NOP4()  NOP3(),NOP1()
#define NOP5()  NOP4(),NOP1()
#define NOP6()  NOP5(),NOP1()
#define NOP7()  NOP6(),NOP1()
#define NOP8()  NOP7(),NOP1()
#define NOP9()  NOP8(),NOP1()
#define NOP10() NOP9(),NOP1()
#define NOP(N)  NOP##N()

#define  DISABLE_GIE()     EA = 0      //رж
#define  ENABLE_GIE()      EA = 1      //ʹж

/*  SLPCR, 0x86H, SFR0  */  

/*  PCON, 0x87H, SFR0  */
#define SET_UART1EN()         PCON|=DEF_SET_BIT7      // PCON^7;
#define CLR_UART1EN()         PCON&=~DEF_SET_BIT7
// PCON^6;
// PCON^5;
#define SET_UART0EN()         PCON|=DEF_SET_BIT4      // PCON^4;
#define CLR_UART0EN()         PCON&=~DEF_SET_BIT4
#define SET_SMOD0()           PCON|=DEF_SET_BIT3      // PCON^3;
#define CLR_SMOD0()           PCON&=~DEF_SET_BIT3
#define SET_SSTAT0()          PCON|=DEF_SET_BIT2      // PCON^2;
#define CLR_SSTAT0()          PCON&=~DEF_SET_BIT2
#define SET_SLEEP()           PCON|=DEF_SET_BIT1      // PCON^1;
#define SET_STOP()            PCON|=DEF_SET_BIT0      // PCON^0;

/*  TCON, 0x88H, SFR0  */

/*  TMOD, 0x89H, SFR0  */
#define SET_GATE1()           TMOD|=DEF_SET_BIT7      // TMOD^7;
#define CLR_GATE1()           TMOD&=~DEF_SET_BIT7
#define SET_CT1()             TMOD|=DEF_SET_BIT6      // TMOD^6; 
#define CLR_CT1()             TMOD&=~DEF_SET_BIT6 
#define SET_T1M1()            TMOD|=DEF_SET_BIT5      // TMOD^5; 
#define CLR_T1M1()            TMOD&=~DEF_SET_BIT5
#define SET_T1M0()            TMOD|=DEF_SET_BIT4      // TMOD^4; 
#define CLR_T1M0()            TMOD&=~DEF_SET_BIT4
#define SET_GATE0()           TMOD|=DEF_SET_BIT3      // TMOD^3; 
#define CLR_GATE0()           TMOD&=~DEF_SET_BIT3
#define SET_CT0()             TMOD|=DEF_SET_BIT2      // TMOD^2;
#define CLR_CT0()             TMOD&=~DEF_SET_BIT2
#define SET_T0M1()            TMOD|=DEF_SET_BIT1      // TMOD^1;
#define CLR_T0M1()            TMOD&=~DEF_SET_BIT1
#define SET_T0M0()            TMOD|=DEF_SET_BIT0      // TMOD^0;
#define CLR_T0M0()            TMOD&=~DEF_SET_BIT0

/*  TL0, 0x8AH, SFR0  */

/*  TL1, 0x8BH, SFR0  */

/*  TH0, 0x8CH, SFR0  */

/*  TH1, 0x8DH, SFR0  */

/*  TCON1, 0x8EH, SFR0  */
#define SET_T1FS()       TCON1|=DEF_SET_BIT7     // TCON1^7;
#define CLR_T1FS()       TCON1&=~DEF_SET_BIT7
#define SET_T1OE()       TCON1|=DEF_SET_BIT6     // TCON1^6;
#define CLR_T1OE()       TCON1&=~DEF_SET_BIT6
#define SET_T1CKS1()     TCON1|=DEF_SET_BIT5     // TCON1^5;
#define CLR_T1CKS1()     TCON1&=~DEF_SET_BIT5
#define SET_T1CKS0()     TCON1|=DEF_SET_BIT4     // TCON1^4;
#define CLR_T1CKS0()     TCON1&=~DEF_SET_BIT4
#define SET_T0FS()       TCON1|=DEF_SET_BIT3     // TCON1^3;
#define CLR_T0FS()       TCON1&=~DEF_SET_BIT3
#define SET_T0OE()       TCON1|=DEF_SET_BIT2     // TCON1^2;
#define CLR_T0OE()       TCON1&=~DEF_SET_BIT2
#define SET_T0CKS1()     TCON1|=DEF_SET_BIT1     // TCON1^1;
#define CLR_T0CKS1()     TCON1&=~DEF_SET_BIT1
#define SET_T0CKS0()     TCON1|=DEF_SET_BIT0     // TCON1^0;
#define CLR_T0CKS0()     TCON1&=~DEF_SET_BIT0

/*  T3CR, 0x8FH, SFR0  */
#define SET_TR3()        T3CR|=DEF_SET_BIT7      // T3CR^7;
#define CLR_TR3()        T3CR&=~DEF_SET_BIT7
#define SET_CT3()        T3CR|=DEF_SET_BIT6      // T3CR^6;
#define CLR_CT3()        T3CR&=~DEF_SET_BIT6
#define SET_T3F()        T3CR|=DEF_SET_BIT5      // T3CR^5;
#define CLR_T3F()        T3CR&=~DEF_SET_BIT5 
// T3CR^4;
#define SET_T3EN()       T3CR|=DEF_SET_BIT3      // T3CR^3;
#define CLR_T3EN()       T3CR&=~DEF_SET_BIT3
#define SET_T3CKS2()     T3CR|=DEF_SET_BIT2      // T3CR^2;
#define CLR_T3CKS2()     T3CR&=~DEF_SET_BIT2
#define SET_T3CKS1()     T3CR|=DEF_SET_BIT1      // T3CR^1;
#define CLR_T3CKS1()     T3CR&=~DEF_SET_BIT1 
#define SET_T3CKS0()     T3CR|=DEF_SET_BIT0      // T3CR^0;
#define CLR_T3CKS0()     T3CR&=~DEF_SET_BIT0

/*  P1, 0x90H, SFR0  */

/*  P1MOD0, 0x91H, SFR0  */

/*  P1MOD1, 0x92H, SFR0  */

/*  P1PU, 0x93H, SFR0  */

/*  BRGL, 0x94H, SFR0  */

/*  BRGH, 0x95H, SFR0  */

/*  TL3, 0x96H, SFR0  */

/*  TH3, 0x97H, SFR0  */

/*  SCON, 0x98H, SFR0  */

/*  SBUF, 0x99H, SFR0  */

/*  SADDR, 0x9AH, SFR0  */

/*  SADEN, 0x9BH, SFR0  */
#define SET_SADEN7()   SADEN |= DEF_SET_BIT7     // SADEN^7;
#define CLR_SADEN7()   SADEN &=~DEF_SET_BIT7
#define SET_SADEN6()   SADEN |= DEF_SET_BIT6     // SADEN^6;
#define CLR_SADEN6()   SADEN &=~DEF_SET_BIT6
#define SET_SADEN5()   SADEN |= DEF_SET_BIT5     // SADEN^5;
#define CLR_SADEN5()   SADEN &=~DEF_SET_BIT5
#define SET_SADEN4()   SADEN |= DEF_SET_BIT4     // SADEN^4;
#define CLR_SADEN4()   SADEN &=~DEF_SET_BIT4
#define SET_SADEN3()   SADEN |= DEF_SET_BIT3     // SADEN^3;
#define CLR_SADEN3()   SADEN &=~DEF_SET_BIT3
#define SET_SADEN2()   SADEN |= DEF_SET_BIT2     // SADEN^2;
#define CLR_SADEN2()   SADEN &=~DEF_SET_BIT2
#define SET_SADEN1()   SADEN |= DEF_SET_BIT1     // SADEN^1;
#define CLR_SADEN1()   SADEN &=~DEF_SET_BIT1
#define SET_SADEN0()   SADEN |= DEF_SET_BIT0     // SADEN^0;
#define CLR_SADEN0()   SADEN &=~DEF_SET_BIT0

/*  SCON_1, 0x9CH, SFR0  */
#define SET_SM0_1()   SCON_1 |= DEF_SET_BIT7     // SCON_1^7;
#define CLR_SM0_1()   SCON_1 &=~DEF_SET_BIT7
#define SET_SM1_1()   SCON_1 |= DEF_SET_BIT6     // SCON_1^6;
#define CLR_SM1_1()   SCON_1 &=~DEF_SET_BIT6
#define SET_SM2_1()   SCON_1 |= DEF_SET_BIT5     // SCON_1^5;
#define CLR_SM2_1()   SCON_1 &=~DEF_SET_BIT5
#define SET_REN_1()   SCON_1 |= DEF_SET_BIT4     // SCON_1^4;
#define CLR_REN_1()   SCON_1 &=~DEF_SET_BIT4
#define SET_TB8_1()   SCON_1 |= DEF_SET_BIT3     // SCON_1^3;
#define CLR_TB8_1()   SCON_1 &=~DEF_SET_BIT3
#define SET_RB8_1()   SCON_1 |= DEF_SET_BIT2     // SCON_1^2;
#define CLR_RB8_1()   SCON_1 &=~DEF_SET_BIT2
#define SET_TI_1()    SCON_1 |= DEF_SET_BIT1     // SCON_1^1;
#define CLR_TI_1()    SCON_1 &=~DEF_SET_BIT1
#define SET_RI_1()    SCON_1 |= DEF_SET_BIT0     // SCON_1^0;
#define CLR_RI_1()    SCON_1 &=~DEF_SET_BIT0

/*  SBUF_1, 0x9DH, SFR0  */

/*  PXODM, 0x9FH, SFR0  */

/*  P2, 0xA0H, SFR0  */

/*  P2MOD0, 0xA1H, SFR0  */

/*  P2MOD1, 0xA2H, SFR0  */

/*  P2PU, 0xA3H, SFR0  */

/*  CMP0CR0, 0xA4H, SFR0  */
#define SET_C0EN()        CMP0CR0 |= DEF_SET_BIT7     // CMP0CR0^7;
#define CLR_C0EN()        CMP0CR0 &=~DEF_SET_BIT7
#define SET_C0TRGPOL()    CMP0CR0 |= DEF_SET_BIT6     // CMP0CR0^6;
#define CLR_C0TRGPOL()    CMP0CR0 &=~DEF_SET_BIT6
#define SET_C0FILT2()     CMP0CR0 |= DEF_SET_BIT5     // CMP0CR0^5;
#define CLR_C0FILT2()     CMP0CR0 &=~DEF_SET_BIT5
#define SET_C0RFSEL()     CMP0CR0 |= DEF_SET_BIT4     // CMP0CR0^4;
#define CLR_C0RFSEL()     CMP0CR0 &=~DEF_SET_BIT4
#define SET_C0SMT1()      CMP0CR0 |= DEF_SET_BIT3     // CMP0CR0^3;
#define CLR_C0SMT1()      CMP0CR0 &=~DEF_SET_BIT3
#define SET_C0SMT0()      CMP0CR0 |= DEF_SET_BIT2     // CMP0CR0^2;
#define CLR_C0SMT0()      CMP0CR0 &=~DEF_SET_BIT2
#define SET_C0FILT1()     CMP0CR0 |= DEF_SET_BIT1     // CMP0CR0^1;
#define CLR_C0FILT1()     CMP0CR0 &=~DEF_SET_BIT1
#define SET_C0FILT0()     CMP0CR0 |= DEF_SET_BIT0     // CMP0CR0^0;
#define CLR_C0FILT0()     CMP0CR0 &=~DEF_SET_BIT0

/*  CMP0CR1, 0xA5H, SFR0  */
#define SET_C0INV()       CMP0CR1 |= DEF_SET_BIT7     // CMP0CR1^7;
#define CLR_C0INV()       CMP0CR1 &=~DEF_SET_BIT7
#define SET_C0IE()        CMP0CR1 |= DEF_SET_BIT6     // CMP0CR1^6;
#define CLR_C0IE()        CMP0CR1 &=~DEF_SET_BIT6
#define SET_C0INSEL1()    CMP0CR1 |= DEF_SET_BIT5     // CMP0CR1^5;
#define CLR_C0INSEL1()    CMP0CR1 &=~DEF_SET_BIT5
#define SET_C0INSEL0()    CMP0CR1 |= DEF_SET_BIT4     // CMP0CR1^4;
#define CLR_C0INSEL0()    CMP0CR1 &=~DEF_SET_BIT4
#define SET_C0IS1()       CMP0CR1 |= DEF_SET_BIT3     // CMP0CR1^3;
#define CLR_C0IS1()       CMP0CR1 &=~DEF_SET_BIT3
#define SET_COIS0()       CMP0CR1 |= DEF_SET_BIT2     // CMP0CR1^2;
#define CLR_COIS0()       CMP0CR1 &=~DEF_SET_BIT2
#define SET_C0OUT()       CMP0CR1 |= DEF_SET_BIT1     // CMP0CR1^1;
#define CLR_C0OUT()       CMP0CR1 &=~DEF_SET_BIT1
#define SET_C0IF()        CMP0CR1 |= DEF_SET_BIT0     // CMP0CR1^0;
#define CLR_C0IF()        CMP0CR1 &=~DEF_SET_BIT0

/*  CMP0CR2, 0xA6H, SFR0  */

/*  CMP0CR3, 0xA7H, SFR0  */

/*  IE, 0xA8H, SFR0  */
#define SET_EA()          IE |= DEF_SET_BIT7          // IE^7;
#define CLR_EA()          IE &=~DEF_SET_BIT7
#define SET_ADCIE()       IE |= DEF_SET_BIT6          // IE^6;
#define CLR_ADCIE()       IE &=~DEF_SET_BIT6
#define SET_SPIIE()       IE |= DEF_SET_BIT5          // IE^5;
#define CLR_SPIIE()       IE &=~DEF_SET_BIT5
#define SET_UART0IE()     IE |= DEF_SET_BIT4          // IE^4;
#define CLR_UART0IE()     IE &=~DEF_SET_BIT4
#define SET_T1IE()        IE |= DEF_SET_BIT3          // IE^3;
#define CLR_T1IE()        IE &=~DEF_SET_BIT3
#define SET_EXT1IE()      IE |= DEF_SET_BIT2          // IE^2;
#define CLR_EXT1IE()      IE &=~DEF_SET_BIT2
#define SET_T0IE()        IE |= DEF_SET_BIT1          // IE^1;
#define CLR_T0IE()        IE &=~DEF_SET_BIT1
#define SET_EXT0IE()      IE |= DEF_SET_BIT0          // IE^0;
#define CLR_EXT0IE()      IE &=~DEF_SET_BIT0

/*  IE1, 0xA9H, SFR0  */
#define SET_CSSCRCIE()     IE1 |= DEF_SET_BIT7        // IE1^7;
#define CLR_CSSCRCIE()     IE1 &=~DEF_SET_BIT7
#define SET_CMPIE()        IE1 |= DEF_SET_BIT6        // IE1^6;
#define CLR_CMPIE()        IE1 &=~DEF_SET_BIT6
#define SET_PWM1FBIE()     IE1 |= DEF_SET_BIT5        // IE1^5;
#define CLR_PWM1FBIE()     IE1 &=~DEF_SET_BIT5
#define SET_PWM0IE()       IE1 |= DEF_SET_BIT4        // IE1^4;
#define CLR_PWM0IE()       IE1 &=~DEF_SET_BIT4
#define SET_UART1IE()      IE1 |= DEF_SET_BIT3        // IE1^3;
#define CLR_UART1IE()      IE1 &=~DEF_SET_BIT3
#define SET_PWM1IE()       IE1 |= DEF_SET_BIT2        // IE1^2;
#define CLR_PWM1IE()       IE1 &=~DEF_SET_BIT2
#define SET_T3IE()         IE1 |= DEF_SET_BIT1        // IE1^1;
#define CLR_T3IE()         IE1 &=~DEF_SET_BIT1
#define SET_T2IE()         IE1 |= DEF_SET_BIT0        // IE1^0;
#define CLR_T2IE()         IE1 &=~DEF_SET_BIT0

/*  EXTIS2, 0xAAH, SFR0  */
#define SET_EXT0A()        EXTIS2 |= DEF_SET_BIT7     // EXTIS2^7;
#define CLR_EXT0A()        EXTIS2 &=~DEF_SET_BIT7
#define SET_EXT1A()        EXTIS2 |= DEF_SET_BIT6     // EXTIS2^6;
#define CLR_EXT1A()        EXTIS2 &=~DEF_SET_BIT6
// EXTIS2^5;
// EXTIS2^4;
#define SET_EXT1IS1()      EXTIS2 |= DEF_SET_BIT3     // EXTIS2^3;
#define CLR_EXT1IS1()      EXTIS2 &=~DEF_SET_BIT3
#define SET_EXT1IS0()      EXTIS2 |= DEF_SET_BIT2     // EXTIS2^2;
#define CLR_EXT1IS0()      EXTIS2 &=~DEF_SET_BIT2
#define SET_EXT0IS1()      EXTIS2 |= DEF_SET_BIT1     // EXTIS2^1;
#define CLR_EXT0IS1()      EXTIS2 &=~DEF_SET_BIT1
#define SET_EXT0IS0()      EXTIS2 |= DEF_SET_BIT0     // EXTIS2^0;
#define CLR_EXT0IS0()      EXTIS2 &=~DEF_SET_BIT0

/*  EXTIS1, 0xABH, SFR0  */
#define SET_EXT1IF7()      EXTIS1 |= DEF_SET_BIT7     // EXTIS1^7;
#define CLR_EXT1IF7()      EXTIS1 &=~DEF_SET_BIT7
#define SET_EXT1IF6()      EXTIS1 |= DEF_SET_BIT6     // EXTIS1^6;
#define CLR_EXT1IF6()      EXTIS1 &=~DEF_SET_BIT6
#define SET_EXT1IF5()      EXTIS1 |= DEF_SET_BIT5     // EXTIS1^5;
#define CLR_EXT1IF5()      EXTIS1 &=~DEF_SET_BIT5
#define SET_EXT1IF4()      EXTIS1 |= DEF_SET_BIT4     // EXTIS1^4;
#define CLR_EXT1IF4()      EXTIS1 &=~DEF_SET_BIT4
#define SET_EXT1IF3()      EXTIS1 |= DEF_SET_BIT3     // EXTIS1^3;
#define CLR_EXT1IF3()      EXTIS1 &=~DEF_SET_BIT3
#define SET_EXT1IF2()      EXTIS1 |= DEF_SET_BIT2     // EXTIS1^2;
#define CLR_EXT1IF2()      EXTIS1 &=~DEF_SET_BIT2
#define SET_EXT1IF1()      EXTIS1 |= DEF_SET_BIT1     // EXTIS1^1;
#define CLR_EXT1IF1()      EXTIS1 &=~DEF_SET_BIT1
#define SET_EXT1IF0()      EXTIS1 |= DEF_SET_BIT0     // EXTIS1^0;
#define CLR_EXT1IF0()      EXTIS1 &=~DEF_SET_BIT0

/*  EXTIS, 0xACH, SFR0  */
#define SET_EXT0IF7()       EXTIS |= DEF_SET_BIT7     // EXTIS^7;
#define CLR_EXT0IF7()       EXTIS &=~DEF_SET_BIT7
#define SET_EXT0IF6()       EXTIS |= DEF_SET_BIT6     // EXTIS^6;
#define CLR_EXT0IF6()       EXTIS &=~DEF_SET_BIT6
#define SET_EXT0IF5()       EXTIS |= DEF_SET_BIT5     // EXTIS^5;
#define CLR_EXT0IF5()       EXTIS &=~DEF_SET_BIT5
#define SET_EXT0IF4()       EXTIS |= DEF_SET_BIT4     // EXTIS^4;
#define CLR_EXT0IF4()       EXTIS &=~DEF_SET_BIT4
#define SET_EXT0IF3()       EXTIS |= DEF_SET_BIT3     // EXTIS^3;
#define CLR_EXT0IF3()       EXTIS &=~DEF_SET_BIT3
#define SET_EXT0IF2()       EXTIS |= DEF_SET_BIT2     // EXTIS^2;
#define CLR_EXT0IF2()       EXTIS &=~DEF_SET_BIT2
#define SET_EXT0IF1()       EXTIS |= DEF_SET_BIT1     // EXTIS^1;
#define CLR_EXT0IF1()       EXTIS &=~DEF_SET_BIT1
#define SET_EXT0IF0()       EXTIS |= DEF_SET_BIT0     // EXTIS^0;
#define CLR_EXT0IF0()       EXTIS &=~DEF_SET_BIT0

/*  SPCON, 0xADH, SFR0  */
#define SET_DIR()         SPCON |= DEF_SET_BIT7       // SPCON^7;
#define CLR_DIR()         SPCON &=~DEF_SET_BIT7
#define SET_MSTR()        SPCON |= DEF_SET_BIT6       // SPCON^6;
#define CLR_MSTR()        SPCON &=~DEF_SET_BIT6
#define SET_CPHA()        SPCON |= DEF_SET_BIT5       // SPCON^5;
#define CLR_CPHA()        SPCON &=~DEF_SET_BIT5
#define SET_CPOL()        SPCON |= DEF_SET_BIT4       // SPCON^4;
#define CLR_CPOL()        SPCON &=~DEF_SET_BIT4
#define SET_SSDIS()       SPCON |= DEF_SET_BIT3       // SPCON^3;
#define CLR_SSDIS()       SPCON &=~DEF_SET_BIT3
#define SET_SPR2()        SPCON |= DEF_SET_BIT2       // SPCON^2;
#define CLR_SPR2()        SPCON &=~DEF_SET_BIT2
#define SET_SPR1()        SPCON |= DEF_SET_BIT1       // SPCON^1;
#define CLR_SPR1()        SPCON &=~DEF_SET_BIT1
#define SET_SPR0()        SPCON |= DEF_SET_BIT0       // SPCON^0;
#define CLR_SPR0()        SPCON &=~DEF_SET_BIT0

/*  SPSTA, 0xAEH, SFR0  */
#define SET_SPEN()     SPSTA |= DEF_SET_BIT7     // SPSTA^7;
#define CLR_SPEN()     SPSTA &=~DEF_SET_BIT7
#define SET_SPIF()     SPSTA |= DEF_SET_BIT6     // SPSTA^6;
#define CLR_SPIF()     SPSTA &=~DEF_SET_BIT6
#define SET_MODF()     SPSTA |= DEF_SET_BIT5     // SPSTA^5;
#define CLR_MODF()     SPSTA &=~DEF_SET_BIT5
#define SET_WCOL()     SPSTA |= DEF_SET_BIT4     // SPSTA^4;
#define CLR_WCOL()     SPSTA &=~DEF_SET_BIT4
#define SET_SPIOV()    SPSTA |= DEF_SET_BIT3     // SPSTA^3;
#define CLR_SPIOV()    SPSTA &=~DEF_SET_BIT3
// SPSTA^2;
// SPSTA^1;
// SPSTA^0;

/*  SPDAT, 0xAFH, SFR0  */

/*  P3MOD0, 0xB1H, SFR0  */

/*  P3MOD1, 0xB2H, SFR0  */

/*  P3PU, 0xB3H, SFR0  */

/*  EXTEN1, 0xB4H, SFR0  */
#define SET_EXT1EN7()      EXTEN1 |= DEF_SET_BIT7     // EXTEN1^7;
#define CLR_EXT1EN7()      EXTEN1 &=~DEF_SET_BIT7
#define SET_EXT1EN6()      EXTEN1 |= DEF_SET_BIT6     // EXTEN1^6;
#define CLR_EXT1EN6()      EXTEN1 &=~DEF_SET_BIT6
#define SET_EXT1EN5()      EXTEN1 |= DEF_SET_BIT5     // EXTEN1^5;
#define CLR_EXT1EN5()      EXTEN1 &=~DEF_SET_BIT5
#define SET_EXT1EN4()      EXTEN1 |= DEF_SET_BIT4     // EXTEN1^4;
#define CLR_EXT1EN4()      EXTEN1 &=~DEF_SET_BIT4
#define SET_EXT1EN3()      EXTEN1 |= DEF_SET_BIT3     // EXTEN1^3;
#define CLR_EXT1EN3()      EXTEN1 &=~DEF_SET_BIT3
#define SET_EXT1EN2()      EXTEN1 |= DEF_SET_BIT2     // EXTEN1^2;
#define CLR_EXT1EN2()      EXTEN1 &=~DEF_SET_BIT2
#define SET_EXT1EN1()      EXTEN1 |= DEF_SET_BIT1     // EXTEN1^1;
#define CLR_EXT1EN1()      EXTEN1 &=~DEF_SET_BIT1
#define SET_EXT1EN0()      EXTEN1 |= DEF_SET_BIT0     // EXTEN1^0;
#define CLR_EXT1EN0()      EXTEN1 &=~DEF_SET_BIT0

/*  EXTEN, 0xB5H, SFR0  */
#define SET_EXT0EN7()       EXTEN |= DEF_SET_BIT7     // EXTEN^7;
#define CLR_EXT0EN7()       EXTEN &=~DEF_SET_BIT7
#define SET_EXT0EN6()       EXTEN |= DEF_SET_BIT6     // EXTEN^6;
#define CLR_EXT0EN6()       EXTEN &=~DEF_SET_BIT6
#define SET_EXT0EN5()       EXTEN |= DEF_SET_BIT5     // EXTEN^5;
#define CLR_EXT0EN5()       EXTEN &=~DEF_SET_BIT5
#define SET_EXT0EN4()       EXTEN |= DEF_SET_BIT4     // EXTEN^4;
#define CLR_EXT0EN4()       EXTEN &=~DEF_SET_BIT4
#define SET_EXT0EN3()       EXTEN |= DEF_SET_BIT3     // EXTEN^3;
#define CLR_EXT0EN3()       EXTEN &=~DEF_SET_BIT3
#define SET_EXT0EN2()       EXTEN |= DEF_SET_BIT2     // EXTEN^2;
#define CLR_EXT0EN2()       EXTEN &=~DEF_SET_BIT2
#define SET_EXT0EN1()       EXTEN |= DEF_SET_BIT1     // EXTEN^1;
#define CLR_EXT0EN1()       EXTEN &=~DEF_SET_BIT1
#define SET_EXT0EN0()       EXTEN |= DEF_SET_BIT0     // EXTEN^0;
#define CLR_EXT0EN0()       EXTEN &=~DEF_SET_BIT0

/*  PWM1MANCR0, 0xB6H, SFR0  */
// PWM1MANCR0^7;
// PWM1MANCR0^6;
#define SET_MANCN()    PWM1MANCR0 |= DEF_SET_BIT5     // PWM1MANCR0^5;
#define CLR_MANCN()    PWM1MANCR0 &=~DEF_SET_BIT5
#define SET_MANBN()    PWM1MANCR0 |= DEF_SET_BIT4     // PWM1MANCR0^4;
#define CLR_MANBN()    PWM1MANCR0 &=~DEF_SET_BIT4
#define SET_MANAN()    PWM1MANCR0 |= DEF_SET_BIT3     // PWM1MANCR0^3;
#define CLR_MANAN()    PWM1MANCR0 &=~DEF_SET_BIT3
#define SET_MANC()     PWM1MANCR0 |= DEF_SET_BIT2     // PWM1MANCR0^2;
#define CLR_MANC()     PWM1MANCR0 &=~DEF_SET_BIT2
#define SET_MANB()     PWM1MANCR0 |= DEF_SET_BIT1     // PWM1MANCR0^1;
#define CLR_MANB()     PWM1MANCR0 &=~DEF_SET_BIT1
#define SET_MANA()     PWM1MANCR0 |= DEF_SET_BIT0     // PWM1MANCR0^0;
#define CLR_MANA()     PWM1MANCR0 &=~DEF_SET_BIT0

/*  PWM1MANCR1, 0xB7H, SFR0  */
// PWM1MANCR1^7;
// PWM1MANCR1^6;
#define SET_PWMOCN()    PWM1MANCR1 |= DEF_SET_BIT5    // PWM1MANCR1^5;
#define CLR_PWMOCN()    PWM1MANCR1 &=~DEF_SET_BIT5
#define SET_PWMOBN()    PWM1MANCR1 |= DEF_SET_BIT4    // PWM1MANCR1^4;
#define CLR_PWMOBN()    PWM1MANCR1 &=~DEF_SET_BIT4
#define SET_PWMOAN()    PWM1MANCR1 |= DEF_SET_BIT3    // PWM1MANCR1^3;
#define CLR_PWMOAN()    PWM1MANCR1 &=~DEF_SET_BIT3
#define SET_PWMOC()     PWM1MANCR1 |= DEF_SET_BIT2    // PWM1MANCR1^2;
#define CLR_PWMOC()     PWM1MANCR1 &=~DEF_SET_BIT2
#define SET_PWMOB()     PWM1MANCR1 |= DEF_SET_BIT1    // PWM1MANCR1^1;
#define CLR_PWMOB()     PWM1MANCR1 &=~DEF_SET_BIT1
#define SET_PWMOA()     PWM1MANCR1 |= DEF_SET_BIT0    // PWM1MANCR1^0;
#define CLR_PWMOA()     PWM1MANCR1 &=~DEF_SET_BIT0

/*  PWM1IF, 0xB8H, SFR0  */
#define SET_PWMPIF()       PWM1IF |= DEF_SET_BIT7     // PWM1IF^7;
#define CLR_PWMPIF()       PWM1IF &=~DEF_SET_BIT7
#define SET_PWMZIF()       PWM1IF |= DEF_SET_BIT6     // PWM1IF^6;
#define CLR_PWMZIF()       PWM1IF &=~DEF_SET_BIT6
#define SET_PWMDDCIF()     PWM1IF |= DEF_SET_BIT5     // PWM1IF^5;
#define CLR_PWMDDCIF()     PWM1IF &=~DEF_SET_BIT5
#define SET_PWMUDCIF()     PWM1IF |= DEF_SET_BIT4     // PWM1IF^4;
#define CLR_PWMUDCIF()     PWM1IF &=~DEF_SET_BIT4
#define SET_PWMDDBIF()     PWM1IF |= DEF_SET_BIT3     // PWM1IF^3;
#define CLR_PWMDDBIF()     PWM1IF &=~DEF_SET_BIT3
#define SET_PWMUDBIF()     PWM1IF |= DEF_SET_BIT2     // PWM1IF^2;
#define CLR_PWMUDBIF()     PWM1IF &=~DEF_SET_BIT2
#define SET_PWMDDAIF()     PWM1IF |= DEF_SET_BIT1     // PWM1IF^1;
#define CLR_PWMDDAIF()     PWM1IF &=~DEF_SET_BIT1
#define SET_PWMUDAIF()     PWM1IF |= DEF_SET_BIT0     // PWM1IF^0;
#define CLR_PWMUDAIF()     PWM1IF &=~DEF_SET_BIT0

/*  IP, 0xB9H, SFR0  */
// T3CR^7;
#define SET_ADCIPL()        IP |= DEF_SET_BIT6        // IP^6;
#define CLR_ADCIPL()        IP &=~DEF_SET_BIT6
#define SET_SPIIPL()        IP |= DEF_SET_BIT5        // IP^5;
#define CLR_SPIIPL()        IP &=~DEF_SET_BIT5
#define SET_UART0IPL()      IP |= DEF_SET_BIT4        // IP^4;
#define CLR_UART0IPL()      IP &=~DEF_SET_BIT4
#define SET_T1IPL()         IP |= DEF_SET_BIT3        // IP^3;
#define CLR_T1IPL()         IP &=~DEF_SET_BIT3
#define SET_EX1IPL()        IP |= DEF_SET_BIT2        // IP^2;
#define CLR_EX1IPL()        IP &=~DEF_SET_BIT2
#define SET_T0IPL()         IP |= DEF_SET_BIT1        // IP^1;
#define CLR_T0IPL()         IP &=~DEF_SET_BIT1
#define SET_EX0IPL()        IP |= DEF_SET_BIT0        // IP^0;
#define CLR_EX0IPL()        IP &=~DEF_SET_BIT0

/*  IPH, 0xBAH, SFR0  */
// IPH^7;
#define SET_ADCIPH()      IPH |= DEF_SET_BIT6         // IPH^6;
#define CLR_ADCIPH()      IPH &=~DEF_SET_BIT6
#define SET_SPIIPH()      IPH |= DEF_SET_BIT5         // IPH^5;
#define CLR_SPIIPH()      IPH &=~DEF_SET_BIT5
#define SET_UART0IPH()    IPH |= DEF_SET_BIT4         // IPH^4;
#define CLR_UART0IPH()    IPH &=~DEF_SET_BIT4
#define SET_T1IPH()       IPH |= DEF_SET_BIT3         // IPH^3;
#define CLR_T1IPH()       IPH &=~DEF_SET_BIT3
#define SET_EX1IPH()      IPH |= DEF_SET_BIT2         // IPH^2;
#define CLR_EX1IPH()      IPH &=~DEF_SET_BIT2
#define SET_T0IPH()       IPH |= DEF_SET_BIT1         // IPH^1;
#define CLR_T0IPH()       IPH &=~DEF_SET_BIT1
#define SET_EX0IPH()      IPH |= DEF_SET_BIT0         // IPH^0;
#define CLR_EX0IPH()      IPH &=~DEF_SET_BIT0


/*  IP1, 0xBBH, SFR0  */
#define SET_CRCIPL()        IP1 |= DEF_SET_BIT7       // IP1^7;
#define CLR_CRCIPL()        IP1 &=~DEF_SET_BIT7
#define SET_CMPIPL()        IP1 |= DEF_SET_BIT6       // IP1^6;
#define CLR_CMPIPL()        IP1 &=~DEF_SET_BIT6
#define SET_PWM1FBIPL()     IP1 |= DEF_SET_BIT5       // IP1^5;
#define CLR_PWM1FBIPL()     IP1 &=~DEF_SET_BIT5
#define SET_PWM0IPL()       IP1 |= DEF_SET_BIT4       // IP1^4;
#define CLR_PWM0IPL()       IP1 &=~DEF_SET_BIT4
#define SET_UART1IPL()      IP1 |= DEF_SET_BIT3       // IP1^3;
#define CLR_UART1IPL()      IP1 &=~DEF_SET_BIT3
#define SET_PWM1IPL()       IP1 |= DEF_SET_BIT2       // IP1^2;
#define CLR_PWM1IPL()       IP1 &=~DEF_SET_BIT2
#define SET_T3IPL()         IP1 |= DEF_SET_BIT1       // IP1^1;
#define CLR_T3IPL()         IP1 &=~DEF_SET_BIT1
#define SET_T2IPL()         IP1 |= DEF_SET_BIT0       // IP1^0;
#define CLR_T2IPL()         IP1 &=~DEF_SET_BIT0

/*  IPH1, 0xBCH, SFR0  */
#define SET_CRCIPH()        IPH1 |= DEF_SET_BIT7      // IPH1^7;
#define CLR_CRCIPH()        IPH1 &=~DEF_SET_BIT7
#define SET_CMPIPH()        IPH1 |= DEF_SET_BIT6      // IPH1^6;
#define CLR_CMPIPH()        IPH1 &=~DEF_SET_BIT6
#define SET_PWM1FBIPH()     IPH1 |= DEF_SET_BIT5      // IPH1^5;
#define CLR_PWM1FBIPH()     IPH1 &=~DEF_SET_BIT5
#define SET_PWM0IPH()       IPH1 |= DEF_SET_BIT4      // IPH1^4;
#define CLR_PWM0IPH()       IPH1 &=~DEF_SET_BIT4
#define SET_UART1IPH()      IPH1 |= DEF_SET_BIT3      // IPH1^3;
#define CLR_UART1IPH()      IPH1 &=~DEF_SET_BIT3
#define SET_PWM1IPH()       IPH1 |= DEF_SET_BIT2      // IPH1^2;
#define CLR_PWM1IPH()       IPH1 &=~DEF_SET_BIT2
#define SET_T3IPH()         IPH1 |= DEF_SET_BIT1      // IPH1^1;
#define CLR_T3IPH()         IPH1 &=~DEF_SET_BIT1
#define SET_T2IPH()         IPH1 |= DEF_SET_BIT0      // IPH1^0;
#define CLR_T2IPH()         IPH1 &=~DEF_SET_BIT0

/*  PWM1CR1, 0xBDH, SFR0  */
#define SET_OUTMOD()      PWM1CR1 |= DEF_SET_BIT7     // PWM1CR1^7;
#define CLR_OUTMOD()      PWM1CR1 &=~DEF_SET_BIT7
#define SET_SYMC()        PWM1CR1 |= DEF_SET_BIT6     // PWM1CR1^6;
#define CLR_SYMC()        PWM1CR1 &=~DEF_SET_BIT6
#define SET_PWMCNS()      PWM1CR1 |= DEF_SET_BIT5     // PWM1CR1^5;
#define CLR_PWMCNS()      PWM1CR1 &=~DEF_SET_BIT5
#define SET_PWMBNS()      PWM1CR1 |= DEF_SET_BIT4     // PWM1CR1^4;
#define CLR_PWMBNS()      PWM1CR1 &=~DEF_SET_BIT4
#define SET_PWMANS()      PWM1CR1 |= DEF_SET_BIT3     // PWM1CR1^3;
#define CLR_PWMANS()      PWM1CR1 &=~DEF_SET_BIT3
#define SET_PWMCS()       PWM1CR1 |= DEF_SET_BIT2     // PWM1CR1^2;
#define CLR_PWMCS()       PWM1CR1 &=~DEF_SET_BIT2
#define SET_PWMBS()       PWM1CR1 |= DEF_SET_BIT1     // PWM1CR1^1;
#define CLR_PWMBS()       PWM1CR1 &=~DEF_SET_BIT1
#define SET_PWMAS()       PWM1CR1 |= DEF_SET_BIT0     // PWM1CR1^0;
#define CLR_PWMAS()       PWM1CR1 &=~DEF_SET_BIT0

/*  PWM1CR2, 0xBEH, SFR0  */
#define SET_TRGTIM1()     PWM1CR2 |= DEF_SET_BIT7     // PWM1CR2^7;
#define CLR_TRGTIM1()     PWM1CR2 &=~DEF_SET_BIT7
#define SET_TRGTIM0()     PWM1CR2 |= DEF_SET_BIT6     // PWM1CR2^6;
#define CLR_TRGTIM0()     PWM1CR2 &=~DEF_SET_BIT6
#define SET_PTRGAD()      PWM1CR2 |= DEF_SET_BIT5     // PWM1CR2^5;
#define CLR_PTRGAD()      PWM1CR2 &=~DEF_SET_BIT5
#define SET_ZTRGAD()      PWM1CR2 |= DEF_SET_BIT4     // PWM1CR2^4;
#define CLR_ZTRGAD()      PWM1CR2 &=~DEF_SET_BIT4
#define SET_PLDEN()       PWM1CR2 |= DEF_SET_BIT3     // PWM1CR2^3;
#define CLR_PLDEN()       PWM1CR2 &=~DEF_SET_BIT3
#define SET_OSYNC()       PWM1CR2 |= DEF_SET_BIT2     // PWM1CR2^2;
#define CLR_OSYNC()       PWM1CR2 &=~DEF_SET_BIT2
#define SET_DTMOD1()      PWM1CR2 |= DEF_SET_BIT1     // PWM1CR2^1;
#define CLR_DTMOD1()      PWM1CR2 &=~DEF_SET_BIT1
#define SET_DTMOD0()      PWM1CR2 |= DEF_SET_BIT0     // PWM1CR2^0;
#define CLR_DTMOD0()      PWM1CR2 &=~DEF_SET_BIT0

/*  PWM1FBCR, 0xBFH, SFR0  */
#define SET_FB0EN()       PWM1FBCR |= DEF_SET_BIT7    // PWM1FBCR^7;
#define CLR_FB0EN()       PWM1FBCR &=~DEF_SET_BIT7
#define SET_FB0SEL()      PWM1FBCR |= DEF_SET_BIT6    // PWM1FBCR^6;
#define CLR_FB0SEL()      PWM1FBCR &=~DEF_SET_BIT6
#define SET_FB1EN()       PWM1FBCR |= DEF_SET_BIT5    // PWM1FBCR^5;
#define CLR_FB1EN()       PWM1FBCR &=~DEF_SET_BIT5
#define SET_FB1S()        PWM1FBCR |= DEF_SET_BIT4    // PWM1FBCR^4;
#define CLR_FB1S()        PWM1FBCR &=~DEF_SET_BIT4
#define SET_FB1FLT1()     PWM1FBCR |= DEF_SET_BIT3    // PWM1FBCR^3;
#define CLR_FB1FLT1()     PWM1FBCR &=~DEF_SET_BIT3
#define SET_FB1FLT0()     PWM1FBCR |= DEF_SET_BIT2    // PWM1FBCR^2;
#define CLR_FB1FLT0()     PWM1FBCR &=~DEF_SET_BIT2
#define SET_FBMOD()       PWM1FBCR |= DEF_SET_BIT1    // PWM1FBCR^1;
#define CLR_FBMOD()       PWM1FBCR &=~DEF_SET_BIT1
#define SET_FBSTA()       PWM1FBCR |= DEF_SET_BIT0    // PWM1FBCR^0;
#define CLR_FBSTA()       PWM1FBCR &=~DEF_SET_BIT0

/*  OSCM, 0xC0H, SFR0  */
// OSCM^7;
// OSCM^6;
// OSCM^5;
// OSCM^4;
// OSCM^3;
#define SET_CLKS()          OSCM |= DEF_SET_BIT2      // OSCM^2;
#define CLR_CLKS()          OSCM &=~DEF_SET_BIT2
#define SET_LFEN()          OSCM |= DEF_SET_BIT1      // OSCM^1;
#define CLR_LFEN()          OSCM &=~DEF_SET_BIT1
#define SET_HFEN()          OSCM |= DEF_SET_BIT0      // OSCM^0;
#define CLR_HFEN()          OSCM &=~DEF_SET_BIT0

/*  P0MOD0, 0xC1H, SFR0  */

/*  P0MOD1, 0xC2H, SFR0  */

/*  P0PU, 0xC3H, SFR0  */

/*  CMP1CR0, 0xC4H, SFR0  */

/*  CMP1CR1, 0xC5H, SFR0  */

/*  CMP1CR2, 0xC6H, SFR0  */

/*  CMP1CR3, 0xC7H, SFR0  */

/*  T2CON, 0xC8H, SFR0  */
#define SET_TF2()       T2CON |= DEF_SET_BIT7         // T2CON^7;
#define CLR_TF2()       T2CON &=~DEF_SET_BIT7
#define SET_EXTF2()     T2CON |= DEF_SET_BIT6         // T2CON^6;
#define CLR_EXTF2()     T2CON &=~DEF_SET_BIT6
#define SET_RCLKU0()    T2CON |= DEF_SET_BIT5         // T2CON^5;
#define CLR_RCLKU0()    T2CON &=~DEF_SET_BIT5
#define SET_TCLKU0()    T2CON |= DEF_SET_BIT4         // T2CON^4;
#define CLR_TCLKU0()    T2CON &=~DEF_SET_BIT4
#define SET_EX2EN()     T2CON |= DEF_SET_BIT3         // T2CON^3;
#define CLR_EX2EN()     T2CON &=~DEF_SET_BIT3
#define SET_TR2()       T2CON |= DEF_SET_BIT2         // T2CON^2;
#define CLR_TR2()       T2CON &=~DEF_SET_BIT2
#define SET_CT2()       T2CON |= DEF_SET_BIT1         // T2CON^1;
#define CLR_CT2()       T2CON &=~DEF_SET_BIT1
#define SET_CPRL2()     T2CON |= DEF_SET_BIT0         // T2CON^0;
#define CLR_CPRL2()     T2CON &=~DEF_SET_BIT0

/*  T2MOD, 0xC9H, SFR0  */
#define SET_LD2EN()       T2MOD |= DEF_SET_BIT7       // T2MOD^7;
#define CLR_LD2EN()       T2MOD &=~DEF_SET_BIT7
#define SET_T2CKS2()      T2MOD |= DEF_SET_BIT6       // T2MOD^6;
#define CLR_T2CKS2()      T2MOD &=~DEF_SET_BIT6
#define SET_T2CKS1()      T2MOD |= DEF_SET_BIT5       // T2MOD^5;
#define CLR_T2CKS1()      T2MOD &=~DEF_SET_BIT5
#define SET_T2CKS0()      T2MOD |= DEF_SET_BIT4       // T2MOD^4;
#define CLR_T2CKS0()      T2MOD &=~DEF_SET_BIT4
#define SET_T2OE()        T2MOD |= DEF_SET_BIT3       // T2MOD^3;
#define CLR_T2OE()        T2MOD &=~DEF_SET_BIT3
#define SET_T2SL1()       T2MOD |= DEF_SET_BIT2       // T2MOD^2;
#define CLR_T2SL1()       T2MOD &=~DEF_SET_BIT2
#define SET_T2SL0()       T2MOD |= DEF_SET_BIT1       // T2MOD^1;
#define CLR_T2SL0()       T2MOD &=~DEF_SET_BIT1
// T2MOD^0;


/*  RCAPL2, 0xCAH, SFR0  */

/*  RCAPH2, 0xCBH, SFR0  */

/*  TL2, 0xCCH, SFR0  */

/*  TH2, 0xCDH, SFR0  */

/*  T2CON1, 0xCEH, SFR0  */
#define SET_CM2ON()       T2CON1 |= DEF_SET_BIT7      // T2CON1^7;
#define CLR_CM2ON()       T2CON1 &=~DEF_SET_BIT7
#define SET_CM2()         T2CON1 |= DEF_SET_BIT6      // T2CON1^6;
#define CLR_CM2()         T2CON1 &=~DEF_SET_BIT6
#define SET_BR2EN()       T2CON1 |= DEF_SET_BIT5      // T2CON1^5;
#define CLR_BR2EN()       T2CON1 &=~DEF_SET_BIT5
// T2CON1^4;
// T2CON1^3;
#define SET_EX2SL()       T2CON1 |= DEF_SET_BIT2      // T2CON1^2;
#define CLR_EX2SL()       T2CON1 &=~DEF_SET_BIT2
#define SET_SIGTRG()      T2CON1 |= DEF_SET_BIT1      // T2CON1^1;
#define CLR_SIGTRG()      T2CON1 &=~DEF_SET_BIT1
#define SET_T2EN()        T2CON1 |= DEF_SET_BIT0      // T2CON1^0;
#define CLR_T2EN()        T2CON1 &=~DEF_SET_BIT0

/*  WDTCR, 0xCFH, SFR0  */
// WDTCR^7;
// WDTCR^6;
// WDTCR^5;
// WDTCR^4;
// WDTCR^3;
#define SET_WDTOT2()     WDTCR |= DEF_SET_BIT2        // WDTCR^2;
#define CLR_WDTOT2()     WDTCR &=~DEF_SET_BIT2
#define SET_WDTOT1()     WDTCR |= DEF_SET_BIT1        // WDTCR^1;
#define CLR_WDTOT1()     WDTCR &=~DEF_SET_BIT1
#define SET_WDTOT0()     WDTCR |= DEF_SET_BIT0        // WDTCR^0;
#define CLR_WDTOT0()     WDTCR &=~DEF_SET_BIT0

/*  PWM1OE, 0xD1H, SFR0  */
#define SET_PWM1EN()     PWM1OE |= DEF_SET_BIT7       // PWM1OE^7;
#define CLR_PWM1EN()     PWM1OE &=~DEF_SET_BIT7
// PWM1OE^6;
#define SET_PWMCNOE()    PWM1OE |= DEF_SET_BIT5       // PWM1OE^5;
#define CLR_PWMCNOE()    PWM1OE &=~DEF_SET_BIT5
#define SET_PWMBNOE()    PWM1OE |= DEF_SET_BIT4       // PWM1OE^4;
#define CLR_PWMBNOE()    PWM1OE &=~DEF_SET_BIT4
#define SET_PWMANOE()    PWM1OE |= DEF_SET_BIT3       // PWM1OE^3;
#define CLR_PWMANOE()    PWM1OE &=~DEF_SET_BIT3
#define SET_PWMCOE()     PWM1OE |= DEF_SET_BIT2       // PWM1OE^2;
#define CLR_PWMCOE()     PWM1OE &=~DEF_SET_BIT2
#define SET_PWMBOE()     PWM1OE |= DEF_SET_BIT1       // PWM1OE^1;
#define CLR_PWMBOE()     PWM1OE &=~DEF_SET_BIT1
#define SET_PWMAOE()     PWM1OE |= DEF_SET_BIT0       // PWM1OE^0;
#define CLR_PWMAOE()     PWM1OE &=~DEF_SET_BIT0

/*  PWM1ADL, 0xD2H, SFR0  */

/*  PWM1ADH, 0xD3H, SFR0  */

/*  PWM1BDL, 0xD4H, SFR0  */

/*  PWM1BDH, 0xD5H, SFR0  */

/*  PWM1CDL, 0xD6H, SFR0  */

/*  PWM1CDH, 0xD7H, SFR0  */

/*  PWM1RLEN, 0xD9H, SFR0  */

/*  PWM1ANDL, 0xDAH, SFR0  */

/*  PWM1ANDH, 0xDBH, SFR0  */

/*  PWM1BNDL, 0xDCH, SFR0  */

/*  PWM1BNDH, 0xDDH, SFR0  */

/*  PWM1CNDL, 0xDEH, SFR0  */

/*  PWM1CNDH, 0xDFH, SFR0  */

/*  MDUCR, 0xE1H, SFR0  */
#define SET_MD1()         MDUCR |= DEF_SET_BIT7     // MDUCR^7;
#define CLR_MD1()         MDUCR &=~DEF_SET_BIT7
#define SET_MD0()         MDUCR |= DEF_SET_BIT6     // MDUCR^6;
#define CLR_MD0()         MDUCR &=~DEF_SET_BIT6
#define SET_SDIR()        MDUCR |= DEF_SET_BIT5     // MDUCR^5;
#define CLR_SDIR()        MDUCR &=~DEF_SET_BIT5
// MDUCR^4;
// MDUCR^3;
#define SET_SIGN()        MDUCR |= DEF_SET_BIT2     // MDUCR^2;
#define CLR_SIGN()        MDUCR &=~DEF_SET_BIT2
#define SET_DVERR()       MDUCR |= DEF_SET_BIT1     // MDUCR^1;
#define CLR_DVERR()       MDUCR &=~DEF_SET_BIT1
#define SET_START()       MDUCR |= DEF_SET_BIT0     // MDUCR^0;
#define CLR_START()       MDUCR &=~DEF_SET_BIT0

/*  MDUDRA0, 0xE2H, SFR0  */

/*  MDUDRA1, 0xE3H, SFR0  */

/*  MDUDRA2, 0xE4H, SFR0  */

/*  MDUDRA3, 0xE5H, SFR0  */

/*  MDUDRB0, 0xE6H, SFR0  */

/*  MDUDRB1, 0xE7H, SFR0  */

/*  RSTFLAG, 0xEDH, SFR0  */
#define SET_PORF()        RSTFLAG |= DEF_SET_BIT7     // RSTFLAG^7;
#define CLR_PORF()        RSTFLAG &=~DEF_SET_BIT7
#define SET_LVRF()        RSTFLAG |= DEF_SET_BIT6     // RSTFLAG^6;
#define CLR_LVRF()        RSTFLAG &=~DEF_SET_BIT6
#define SET_RSTF()        RSTFLAG |= DEF_SET_BIT5     // RSTFLAG^5;
#define CLR_RSTF()        RSTFLAG &=~DEF_SET_BIT5
#define SET_WDTRF()       RSTFLAG |= DEF_SET_BIT4     // RSTFLAG^4;
#define CLR_WDTRF()       RSTFLAG &=~DEF_SET_BIT4
#define SET_SWRF()        RSTFLAG |= DEF_SET_BIT3     // RSTFLAG^3;
#define CLR_SWRF()        RSTFLAG &=~DEF_SET_BIT3
// RSTFLAG^2;
// RSTFLAG^1;
#define SET_SWRST()       RSTFLAG |= DEF_SET_BIT0     // RSTFLAG^0;
#define CLR_SWRST()       RSTFLAG &=~DEF_SET_BIT0

/*  IAPCR, 0xE9H, SFR0  */
#define SET_IAPSTR()      IAPCR |= DEF_SET_BIT7      // IAPCR^7;
#define CLR_IAPSTR()      IAPCR &=~DEF_SET_BIT7
// IAPCR^6;
// IAPCR^5;
#define SET_BLRS()        IAPCR |= DEF_SET_BIT4      // IAPCR^4;
#define CLR_BLRS()        IAPCR &=~DEF_SET_BIT4
#define SET_IAPTRIG2()    IAPCR |= DEF_SET_BIT3      // IAPCR^3;
#define CLR_IAPTRIG2()    IAPCR &=~DEF_SET_BIT3
#define SET_IAPTRIG1()    IAPCR |= DEF_SET_BIT2      // IAPCR^2;
#define CLR_IAPTRIG1()    IAPCR &=~DEF_SET_BIT2
#define SET_IAPTRIG0()    IAPCR |= DEF_SET_BIT1      // IAPCR^1;
#define CLR_IAPTRIG0()    IAPCR &=~DEF_SET_BIT1
#define SET_INFOS()       IAPCR |= DEF_SET_BIT0      // IAPCR^0;
#define CLR_INFOS()       IAPCR &=~DEF_SET_BIT0

/*  IAPADL, 0xEAH, SFR0  */

/*  IAPADH, 0xEBH, SFR0  */

/*  IAPDB, 0xECH, SFR0  */

/*  IAPCR1, 0xEDH, SFR0  */
#define SET_BOOT()        IAPCR1 |= DEF_SET_BIT7      // IAPCR1^7;
#define CLR_BOOT()        IAPCR1 &=~DEF_SET_BIT7
#define SET_MFREF()       IAPCR1 |= DEF_SET_BIT6      // IAPCR1^6;
#define CLR_MFREF()       IAPCR1 &=~DEF_SET_BIT6
#define SET_IAPERR()      IAPCR1 |= DEF_SET_BIT5      // IAPCR1^5;
#define CLR_IAPERR()      IAPCR1 &=~DEF_SET_BIT5
// IAPCR1^4;
#define SET_PCFEN()       IAPCR1 |= DEF_SET_BIT3      // IAPCR1^3;
#define CLR_PCFEN()       IAPCR1 &=~DEF_SET_BIT3
#define SET_UCFEN()       IAPCR1 |= DEF_SET_BIT2      // IAPCR1^2;
#define CLR_UCFEN()       IAPCR1 &=~DEF_SET_BIT2
#define SET_BLREN()       IAPCR1 |= DEF_SET_BIT1      // IAPCR1^1;
#define CLR_BLREN()       IAPCR1 &=~DEF_SET_BIT1
#define SET_MFREN()       IAPCR1 |= DEF_SET_BIT0      // IAPCR1^0;
#define CLR_MFREN()       IAPCR1 &=~DEF_SET_BIT0

/*  IAPMD, 0xEEH, SFR0  */
#define SET_IAPEN()        IAPMD |= DEF_SET_BIT7      // IAPMD^7;
#define CLR_IAPEN()        IAPMD &=~DEF_SET_BIT7
// IAPMD^6;
// IAPMD^5;
#define SET_BLOCKERS()     IAPMD |= DEF_SET_BIT4      // IAPMD^4;
#define CLR_BLOCKERS()     IAPMD &=~DEF_SET_BIT4
// IAPMD^3;
#define SET_PAGEERS()      IAPMD |= DEF_SET_BIT2      // IAPMD^2;
#define CLR_PAGEERS()      IAPMD &=~DEF_SET_BIT2
// IAPMD^1;
#define SET_BYTEWR()       IAPMD |= DEF_SET_BIT0      // IAPMD^0;
#define CLR_BYTEWR()       IAPMD &=~DEF_SET_BIT0

/*  IAPKEY, 0xEFH, SFR0  */

/*  AUXC, 0xF1H, SFR0  */

/*  ADCCR0, 0xF2H, SFR0  */
#define SET_CMPEN()       ADCCR0 |= DEF_SET_BIT7      // ADCCR0^7;
#define CLR_CMPEN()       ADCCR0 &=~DEF_SET_BIT7
//#define SET_ADCMPLIF()   ADCCR0 |= DEF_SET_BIT6      // ADCCR0^6;
#define CLR_ADCMPLIF()    ADCCR0 &=~DEF_SET_BIT6
//#define SET_ADCMPGIF()   ADCCR0 |= DEF_SET_BIT5      // ADCCR0^5;    //Ӳ1,0
#define CLR_ADCMPGIF()    ADCCR0 &=~DEF_SET_BIT5
//#define SET_ADCIF()       ADCCR0 |= DEF_SET_BIT4      // ADCCR0^4;    //Ӳ1,0
#define CLR_ADCIF()       ADCCR0 &=~DEF_SET_BIT4
#define SET_VRS1()        ADCCR0 |= DEF_SET_BIT3      // ADCCR0^3;
#define CLR_VRS1()        ADCCR0 &=~DEF_SET_BIT3
#define SET_VRS0()        ADCCR0 |= DEF_SET_BIT2      // ADCCR0^2;
#define CLR_VRS0()        ADCCR0 &=~DEF_SET_BIT2
#define SET_ADEOC()       ADCCR0 |= DEF_SET_BIT1      // ADCCR0^1;
//#define CLR_ADEOC()       ADCCR0 &=~DEF_SET_BIT1                     //Ӳ0,һ
#define SET_ADEN()        ADCCR0 |= DEF_SET_BIT0      // ADCCR0^0;
#define CLR_ADEN()        ADCCR0 &=~DEF_SET_BIT0

/*  ADCCR1, 0xF3H, SFR0  */
#define SET_TMPEN()       ADCCR1 |= DEF_SET_BIT7      // ADCCR1^7;
#define CLR_TMPEN()       ADCCR1 &=~DEF_SET_BIT7
#define SET_ADGAIN1()     ADCCR1 |= DEF_SET_BIT6      // ADCCR1^6;
#define CLR_ADGAIN1()     ADCCR1 &=~DEF_SET_BIT6
#define SET_ADGAIN0()     ADCCR1 |= DEF_SET_BIT5      // ADCCR1^5;
#define CLR_ADGAIN0()     ADCCR1 &=~DEF_SET_BIT5
// ADCCR1^4;
#define SET_ADCHS3()      ADCCR1 |= DEF_SET_BIT3      // ADCCR1^3;
#define CLR_ADCHS3()      ADCCR1 &=~DEF_SET_BIT3
#define SET_ADCHS2()      ADCCR1 |= DEF_SET_BIT2      // ADCCR1^2;
#define CLR_ADCHS2()      ADCCR1 &=~DEF_SET_BIT2
#define SET_ADCHS1()      ADCCR1 |= DEF_SET_BIT1      // ADCCR1^1;
#define CLR_ADCHS1()      ADCCR1 &=~DEF_SET_BIT1
#define SET_ADCHS0()      ADCCR1 |= DEF_SET_BIT0      // ADCCR1^0;
#define CLR_ADCHS0()      ADCCR1 &=~DEF_SET_BIT0

/*  ADCCR3, 0xF4H, SFR0  */
#define SET_ADPAC()       ADCCR3 |= DEF_SET_BIT7      // ADCCR3^7;
#define CLR_ADPAC()       ADCCR3 &=~DEF_SET_BIT7
#define SET_ADRST1()      ADCCR3 |= DEF_SET_BIT6      // ADCCR3^6;
#define CLR_ADRST1()      ADCCR3 &=~DEF_SET_BIT6
#define SET_ADRST0()      ADCCR3 |= DEF_SET_BIT5      // ADCCR3^5;
#define CLR_ADRST0()      ADCCR3 &=~DEF_SET_BIT5
#define SET_ADACC2()      ADCCR3 |= DEF_SET_BIT4      // ADCCR3^4;
#define CLR_ADACC2()      ADCCR3 &=~DEF_SET_BIT4
#define SET_ADACC1()      ADCCR3 |= DEF_SET_BIT3      // ADCCR3^3;
#define CLR_ADACC1()      ADCCR3 &=~DEF_SET_BIT3
#define SET_ADACC0()      ADCCR3 |= DEF_SET_BIT2      // ADCCR3^2;
#define CLR_ADACC0()      ADCCR3 &=~DEF_SET_BIT2
#define SET_ADBIT1()      ADCCR3 |= DEF_SET_BIT1      // ADCCR3^1;
#define CLR_ADBIT1()      ADCCR3 &=~DEF_SET_BIT1
#define SET_ADBIT0()      ADCCR3 |= DEF_SET_BIT0      // ADCCR3^0;
#define CLR_ADBIT0()      ADCCR3 &=~DEF_SET_BIT0

/*  ADCCR4, 0xF5H, SFR0  */
#define SET_EXVRS1()      ADCCR4 |= DEF_SET_BIT7      // ADCCR4^7;
#define CLR_EXVRS1()      ADCCR4 &=~DEF_SET_BIT7
#define SET_EXVRS0()      ADCCR4 |= DEF_SET_BIT6      // ADCCR4^6;
#define CLR_EXVRS0()      ADCCR4 &=~DEF_SET_BIT6
#define SET_EXVREF_EN()   ADCCR4 |= DEF_SET_BIT5      // ADCCR4^5;
#define CLR_EXVREF_EN()   ADCCR4 &=~DEF_SET_BIT5
// ADCCR4^4;
#define SET_ADTRG3()      ADCCR4 |= DEF_SET_BIT3      // ADCCR4^3;
#define CLR_ADTRG3()      ADCCR4 &=~DEF_SET_BIT3
#define SET_ADTRG2()      ADCCR4 |= DEF_SET_BIT2      // ADCCR4^2;
#define CLR_ADTRG2()      ADCCR4 &=~DEF_SET_BIT2
#define SET_ADTRG1()      ADCCR4 |= DEF_SET_BIT1      // ADCCR4^1;
#define CLR_ADTRG1()      ADCCR4 &=~DEF_SET_BIT1
#define SET_ADTRG0()      ADCCR4 |= DEF_SET_BIT0      // ADCCR4^0;
#define CLR_ADTRG0()      ADCCR4 &=~DEF_SET_BIT0

/*  OSCSS, 0xF6H, SFR0  */
#define SET_CSSEN()       OSCSS |= DEF_SET_BIT7       // OSCSS^7;
#define CLR_CSSEN()       OSCSS &=~DEF_SET_BIT7
#define SET_FHS2()        OSCSS |= DEF_SET_BIT6       // OSCSS^6;
#define CLR_FHS2()        OSCSS &=~DEF_SET_BIT6
#define SET_FHS1()        OSCSS |= DEF_SET_BIT5       // OSCSS^5;
#define CLR_FHS1()        OSCSS &=~DEF_SET_BIT5
#define SET_FHS0()        OSCSS |= DEF_SET_BIT4       // OSCSS^4;
#define CLR_FHS0()        OSCSS &=~DEF_SET_BIT4
#define SET_CSSIE()       OSCSS |= DEF_SET_BIT3       // OSCSS^3;
#define CLR_CSSIE()       OSCSS &=~DEF_SET_BIT3
//#define SET_HFSWS()       OSCSS |= DEF_SET_BIT2     // OSCSS^2;  //Ӳ1,0
#define CLR_HFSWS()       OSCSS &=~DEF_SET_BIT2
//#define SET_LFSWS()       OSCSS |= DEF_SET_BIT1     // OSCSS^1;  //Ӳ1,0
#define CLR_LFSWS()       OSCSS &=~DEF_SET_BIT1
//#define SET_CSSF()       OSCSS |= DEF_SET_BIT0      // OSCSS^0;  //Ӳ1,0
#define CLR_CSSF()        OSCSS &=~DEF_SET_BIT0

/*  PWRCR, 0xF8H, SFR0  */
// PWRCR^7;
// PWRCR^6;
#define SET_PWM1_CLKEN()   PWRCR |= DEF_SET_BIT5      // PWRCR^5;
#define CLR_PWM1_CLKEN()   PWRCR &=~DEF_SET_BIT5
#define SET_PWM0_CLKEN()   PWRCR |= DEF_SET_BIT4      // PWRCR^4;
#define CLR_PWM0_CLKEN()   PWRCR &=~DEF_SET_BIT4
#define SET_SPI_CLKEN()    PWRCR |= DEF_SET_BIT3      // PWRCR^3;
#define CLR_SPI_CLKEN()    PWRCR &=~DEF_SET_BIT3
#define SET_ADC_CLKEN()    PWRCR |= DEF_SET_BIT2      // PWRCR^2;
#define CLR_ADC_CLKEN()    PWRCR &=~DEF_SET_BIT2
// PWRCR^1;
#define SET_OCD_CLKEN()    PWRCR |= DEF_SET_BIT0      // PWRCR^0;
#define CLR_OCD_CLKEN()    PWRCR &=~DEF_SET_BIT0

/*  PWRCR1, 0xF9H, SFR0  */
// PWRCR1^7;
// PWRCR1^6;
#define SET_CRC_CLKEN()    PWRCR1 |= DEF_SET_BIT5     // PWRCR1^5;
#define CLR_CRC_CLKEN()    PWRCR1 &=~DEF_SET_BIT5
// PWRCR1^4;
// PWRCR1^3;
#define SET_T3_CLKEN()     PWRCR1 |= DEF_SET_BIT2     // PWRCR1^2;
#define CLR_T3_CLKEN()     PWRCR1 &=~DEF_SET_BIT2
#define SET_T2_CLKEN()     PWRCR1 |= DEF_SET_BIT1     // PWRCR1^1;
#define CLR_T2_CLKEN()     PWRCR1 &=~DEF_SET_BIT1
#define SET_T01_CLKEN()    PWRCR1 |= DEF_SET_BIT0     // PWRCR1^0;
#define CLR_T01_CLKEN()    PWRCR1 &=~DEF_SET_BIT0

/*  ADASCR0, 0xFAH, SFR0  */
#define SET_ADJSTR()      ADASCR0 |= DEF_SET_BIT7     // ADASCR0^7;
#define CLR_ADJSTR()      ADASCR0 &=~DEF_SET_BIT7
// ADASCR0^6;
#define SET_ASCNUM2()      ADASCR0 |= DEF_SET_BIT5    // ADASCR0^5;
#define CLR_ASCNUM2()      ADASCR0 &=~DEF_SET_BIT5
#define SET_ASCNUM1()      ADASCR0 |= DEF_SET_BIT4    // ADASCR0^4;
#define CLR_ASCNUM1()      ADASCR0 &=~DEF_SET_BIT4
#define SET_ASCNUM0()      ADASCR0 |= DEF_SET_BIT3    // ADASCR0^3;
#define CLR_ASCNUM0()      ADASCR0 &=~DEF_SET_BIT3
#define SET_ASSTA()        ADASCR0 |= DEF_SET_BIT2    // ADASCR0^2;
#define CLR_ASSTA()        ADASCR0 &=~DEF_SET_BIT2
#define SET_ASTRG()        ADASCR0 |= DEF_SET_BIT1    // ADASCR0^1;
#define CLR_ASTRG()        ADASCR0 &=~DEF_SET_BIT1
#define SET_ASEN()         ADASCR0 |= DEF_SET_BIT0    // ADASCR0^0;
#define CLR_ASEN()         ADASCR0 &=~DEF_SET_BIT0

/*  ADASCR1, 0xFBH, SFR0  */
/*  ADASCR2, 0xFCH, SFR0  */

/*  ADCCR2, 0xFDH, SFR0  */
#define SET_ADCKS()       ADCCR2 |= DEF_SET_BIT7      // ADCCR2^7;
#define CLR_ADCKS()       ADCCR2 &=~DEF_SET_BIT7
#define SET_ADCKDIV2()    ADCCR2 |= DEF_SET_BIT6      // ADCCR2^6;
#define CLR_ADCKDIV2()    ADCCR2 &=~DEF_SET_BIT6
#define SET_ADCKDIV1()    ADCCR2 |= DEF_SET_BIT5      // ADCCR2^5;
#define CLR_ADCKDIV1()    ADCCR2 &=~DEF_SET_BIT5
#define SET_ADCKDIV0()    ADCCR2 |= DEF_SET_BIT4      // ADCCR2^4;
#define CLR_ADCKDIV0()    ADCCR2 &=~DEF_SET_BIT4
// ADCCR2^3;
#define SET_ADSPS2()      ADCCR2 |= DEF_SET_BIT2      // ADCCR2^2;
#define CLR_ADSPS2()      ADCCR2 &=~DEF_SET_BIT2
#define SET_ADSPS1()      ADCCR2 |= DEF_SET_BIT1      // ADCCR2^1;
#define CLR_ADSPS1()      ADCCR2 &=~DEF_SET_BIT1
#define SET_ADSPS0()      ADCCR2 |= DEF_SET_BIT0      // ADCCR2^0;
#define CLR_ADSPS0()      ADCCR2 &=~DEF_SET_BIT0

/*  ADRL, 0xFEH, SFR0  */

/*  ADRH, 0xFFH, SFR0  */


/*  XSFR  */

/*  ADCMPGH, 0xFF40H, XSFR  */

/*  ADCMPGL, 0xFF41H, XSFR  */

/*  ADCMPLH, 0xFF42H, XSFR  */

/*  ADCMPLL, 0xFF43H, XSFR  */

/*  ADSEQR0, 0xFF46H, XSFR  */
#define SET_SEQ13()       ADSEQR0 |= DEF_SET_BIT7     // ADSEQR0^7;
#define CLR_SEQ13()       ADSEQR0 &=~DEF_SET_BIT7
#define SET_SEQ12()       ADSEQR0 |= DEF_SET_BIT6     // ADSEQR0^6;
#define CLR_SEQ12()       ADSEQR0 &=~DEF_SET_BIT6
#define SET_SEQ11()       ADSEQR0 |= DEF_SET_BIT5     // ADSEQR0^5;
#define CLR_SEQ11()       ADSEQR0 &=~DEF_SET_BIT5
#define SET_SEQ10()       ADSEQR0 |= DEF_SET_BIT4     // ADSEQR0^4;
#define CLR_SEQ10()       ADSEQR0 &=~DEF_SET_BIT4
#define SET_SEQ03()       ADSEQR0 |= DEF_SET_BIT3     // ADSEQR0^3;
#define CLR_SEQ03()       ADSEQR0 &=~DEF_SET_BIT3
#define SET_SEQ02()       ADSEQR0 |= DEF_SET_BIT2     // ADSEQR0^2;
#define CLR_SEQ02()       ADSEQR0 &=~DEF_SET_BIT2
#define SET_SEQ01()       ADSEQR0 |= DEF_SET_BIT1     // ADSEQR0^1;
#define CLR_SEQ01()       ADSEQR0 &=~DEF_SET_BIT1
#define SET_SEQ00()       ADSEQR0 |= DEF_SET_BIT0     // ADSEQR0^0;
#define CLR_SEQ00()       ADSEQR0 &=~DEF_SET_BIT0

/*  ADSEQR1, 0xFF46H, XSFR  */
#define SET_SEQ33()       ADSEQR1 |= DEF_SET_BIT7     // ADSEQR1^7;
#define CLR_SEQ33()       ADSEQR1 &=~DEF_SET_BIT7
#define SET_SEQ32()       ADSEQR1 |= DEF_SET_BIT6     // ADSEQR1^6;
#define CLR_SEQ32()       ADSEQR1 &=~DEF_SET_BIT6
#define SET_SEQ31()       ADSEQR1 |= DEF_SET_BIT5     // ADSEQR1^5;
#define CLR_SEQ31()       ADSEQR1 &=~DEF_SET_BIT5
#define SET_SEQ30()       ADSEQR1 |= DEF_SET_BIT4     // ADSEQR1^4;
#define CLR_SEQ30()       ADSEQR1 &=~DEF_SET_BIT4
#define SET_SEQ23()       ADSEQR1 |= DEF_SET_BIT3     // ADSEQR1^3;
#define CLR_SEQ23()       ADSEQR1 &=~DEF_SET_BIT3
#define SET_SEQ22()       ADSEQR1 |= DEF_SET_BIT2     // ADSEQR1^2;
#define CLR_SEQ22()       ADSEQR1 &=~DEF_SET_BIT2
#define SET_SEQ21()       ADSEQR1 |= DEF_SET_BIT1     // ADSEQR1^1;
#define CLR_SEQ21()       ADSEQR1 &=~DEF_SET_BIT1
#define SET_SEQ20()       ADSEQR1 |= DEF_SET_BIT0     // ADSEQR1^0;
#define CLR_SEQ20()       ADSEQR1 &=~DEF_SET_BIT0

/*  ADSEQR2, 0xFF47H, XSFR  */
#define SET_SEQ53()       ADSEQR2 |= DEF_SET_BIT7     // ADSEQR2^7;
#define CLR_SEQ53()       ADSEQR2 &=~DEF_SET_BIT7
#define SET_SEQ52()       ADSEQR2 |= DEF_SET_BIT6     // ADSEQR2^6;
#define CLR_SEQ52()       ADSEQR2 &=~DEF_SET_BIT6
#define SET_SEQ51()       ADSEQR2 |= DEF_SET_BIT5     // ADSEQR2^5;
#define CLR_SEQ51()       ADSEQR2 &=~DEF_SET_BIT5
#define SET_SEQ50()       ADSEQR2 |= DEF_SET_BIT4     // ADSEQR2^4;
#define CLR_SEQ50()       ADSEQR2 &=~DEF_SET_BIT4
#define SET_SEQ43()       ADSEQR2 |= DEF_SET_BIT3     // ADSEQR2^3;
#define CLR_SEQ43()       ADSEQR2 &=~DEF_SET_BIT3
#define SET_SEQ42()       ADSEQR2 |= DEF_SET_BIT2     // ADSEQR2^2;
#define CLR_SEQ42()       ADSEQR2 &=~DEF_SET_BIT2
#define SET_SEQ41()       ADSEQR2 |= DEF_SET_BIT1     // ADSEQR2^1;
#define CLR_SEQ41()       ADSEQR2 &=~DEF_SET_BIT1
#define SET_SEQ40()       ADSEQR2 |= DEF_SET_BIT0     // ADSEQR2^0;
#define CLR_SEQ40()       ADSEQR2 &=~DEF_SET_BIT0

/*  PWM1CR0, 0xFF48H, XSFR  */
#define SET_CLKSEL()      PWM1CR0 |= DEF_SET_BIT7     // PWM1CR0^7;
#define CLR_CLKSEL()      PWM1CR0 &=~DEF_SET_BIT7
// PWM1CR0^6;
#define SET_CTMOD1()      PWM1CR0 |= DEF_SET_BIT5     // PWM1CR0^5;
#define CLR_CTMOD1()      PWM1CR0 &=~DEF_SET_BIT5
#define SET_CTMOD0()      PWM1CR0 |= DEF_SET_BIT4     // PWM1CR0^4;
#define CLR_CTMOD0()      PWM1CR0 &=~DEF_SET_BIT4
#define SET_PREDIV1()     PWM1CR0 |= DEF_SET_BIT3     // PWM1CR0^3;
#define CLR_PREDIV1()     PWM1CR0 &=~DEF_SET_BIT3
#define SET_PREDIV0()     PWM1CR0 |= DEF_SET_BIT2     // PWM1CR0^2;
#define CLR_PREDIV0()     PWM1CR0 &=~DEF_SET_BIT2
#define SET_POSTDIV1()    PWM1CR0 |= DEF_SET_BIT1     // PWM1CR0^1;
#define CLR_POSTDIV1()    PWM1CR0 &=~DEF_SET_BIT1
#define SET_POSTDIV0()    PWM1CR0 |= DEF_SET_BIT0     // PWM1CR0^0;
#define CLR_POSTDIV0()    PWM1CR0 &=~DEF_SET_BIT0

/*  PWM1IE, 0xFF49H, XSFR  */
#define SET_PWMPIE()       PWM1IE |= DEF_SET_BIT7     // PWM1IE^7;
#define CLR_PWMPIE()       PWM1IE &=~DEF_SET_BIT7
#define SET_PWMZIE()       PWM1IE |= DEF_SET_BIT6     // PWM1IE^6;
#define CLR_PWMZIE()       PWM1IE &=~DEF_SET_BIT6
#define SET_PWMDDCIE()     PWM1IE |= DEF_SET_BIT5     // PWM1IE^5;
#define CLR_PWMDDCIE()     PWM1IE &=~DEF_SET_BIT5
#define SET_PWMUDCIE()     PWM1IE |= DEF_SET_BIT4     // PWM1IE^4;
#define CLR_PWMUDCIE()     PWM1IE &=~DEF_SET_BIT4
#define SET_PWMDDBIE()     PWM1IE |= DEF_SET_BIT3     // PWM1IE^3;
#define CLR_PWMDDBIE()     PWM1IE &=~DEF_SET_BIT3
#define SET_PWMUDBIE()     PWM1IE |= DEF_SET_BIT2     // PWM1IE^2;
#define CLR_PWMUDBIE()     PWM1IE &=~DEF_SET_BIT2
#define SET_PWMDDAIE()     PWM1IE |= DEF_SET_BIT1     // PWM1IE^1;
#define CLR_PWMDDAIE()     PWM1IE &=~DEF_SET_BIT1
#define SET_PWMUDAIE()     PWM1IE |= DEF_SET_BIT0     // PWM1IE^0;
#define CLR_PWMUDAIE()     PWM1IE &=~DEF_SET_BIT0

/*  PWM1PH, 0xFF4AH, XSFR  */

/*  PWM1PL, 0xFF4BH, XSFR  */

/*  PWM1DT0L, 0xFF4DH, XSFR  */

/*  PWM1DT1L, 0xFF4FH, XSFR  */

/*  CRCCR, 0xFF60H, XSFR  */
#define SET_CRCEN()       CRCCR |= DEF_SET_BIT7       // CRCCR^7;
#define CLR_CRCEN()       CRCCR &=~DEF_SET_BIT7
#define SET_CRCIE()       CRCCR |= DEF_SET_BIT6       // CRCCR^6;
#define CLR_CRCIE()       CRCCR &=~DEF_SET_BIT6
//#define SET_CRCIF()       CRCCR |= DEF_SET_BIT5     // CRCCR^5;    //Ӳ1,0
#define CLR_CRCIF()       CRCCR &=~DEF_SET_BIT5
#define SET_CRCST()       CRCCR |= DEF_SET_BIT4       // CRCCR^4;
//#define CLR_CRCST()       CRCCR &=~DEF_SET_BIT4                    //Ӳ0,1
#define SET_CRCMD()       CRCCR |= DEF_SET_BIT3       // CRCCR^3;
#define CLR_CRCMD()       CRCCR &=~DEF_SET_BIT3
#define SET_CRCLCT()      CRCCR |= DEF_SET_BIT2       // CRCCR^2;
#define CLR_CRCLCT()      CRCCR &=~DEF_SET_BIT2
// CRCCR^1;
#define SET_CRCENC()      CRCCR |= DEF_SET_BIT0       // CRCCR^0;
#define CLR_CRCENC()      CRCCR &=~DEF_SET_BIT0

/*  CRCH, 0xFF62H, XSFR  */

/*  CRCL, 0xFF63H, XSFR  */

/*  CRCSTH, 0xFF64H, XSFR  */

/*  CRCSTL, 0xFF65H, XSFR  */

/*  CRCEDH, 0xFF66H, XSFR  */

/*  CRCEDL, 0xFF67H, XSFR  */

/*  PWM0CR, 0xFF68H, XSFR  */
#define SET_PWM0EN()       PWM0CR |= DEF_SET_BIT7     // PWM0CR^7;
#define CLR_PWM0EN()       PWM0CR &=~DEF_SET_BIT7
#define SET_PWM0PIE()      PWM0CR |= DEF_SET_BIT6     // PWM0CR^6;
#define CLR_PWM0PIE()      PWM0CR &=~DEF_SET_BIT6
//#define SET_PWM0IF()       PWM0CR |= DEF_SET_BIT5     // PWM0CR^5;    //Ӳ1,0
#define CLR_PWM0IF()       PWM0CR &=~DEF_SET_BIT5
#define SET_PWM0OE()       PWM0CR |= DEF_SET_BIT4     // PWM0CR^4;
#define CLR_PWM0OE()       PWM0CR &=~DEF_SET_BIT4
#define SET_PWM0S()        PWM0CR |= DEF_SET_BIT3     // PWM0CR^3;
#define CLR_PWM0S()        PWM0CR &=~DEF_SET_BIT3
#define SET_PWM0C2()       PWM0CR |= DEF_SET_BIT2     // PWM0CR^2;
#define CLR_PWM0C2()       PWM0CR &=~DEF_SET_BIT2
#define SET_PWM0C1()       PWM0CR |= DEF_SET_BIT1     // PWM0CR^1;
#define CLR_PWM0C1()       PWM0CR &=~DEF_SET_BIT1
#define SET_PWM0C0()       PWM0CR |= DEF_SET_BIT0     // PWM0CR^0;
#define CLR_PWM0C0()       PWM0CR &=~DEF_SET_BIT0

/*  PWM0P, 0xFF69H, XSFR  */

/*  PWM0D, 0xFF6AH, XSFR  */

/*  OPA0CR0, 0xFF70H, XSFR  */
#define SET_OP0EN()        OPA0CR0 |= DEF_SET_BIT7    // OPA0CR0^7;
#define CLR_OP0EN()        OPA0CR0 &=~DEF_SET_BIT7
// OPA0CR0^6;
#define SET_OP0OE1()       OPA0CR0 |= DEF_SET_BIT5    // OPA0CR0^5;
#define CLR_OP0OE1()       OPA0CR0 &=~DEF_SET_BIT5
#define SET_OP0OE0()       OPA0CR0 |= DEF_SET_BIT4    // OPA0CR0^4;
#define CLR_OP0OE0()       OPA0CR0 &=~DEF_SET_BIT4
// OPA0CR0^3;
#define SET_OP0GAIN2()     OPA0CR0 |= DEF_SET_BIT2    // OPA0CR0^2;
#define CLR_OP0GAIN2()     OPA0CR0 &=~DEF_SET_BIT2
#define SET_OP0GAIN1()     OPA0CR0 |= DEF_SET_BIT1    // OPA0CR0^1;
#define CLR_OP0GAIN1()     OPA0CR0 &=~DEF_SET_BIT1
#define SET_OP0GAIN0()     OPA0CR0 |= DEF_SET_BIT0    // OPA0CR0^0;
#define CLR_OP0GAIN0()     OPA0CR0 &=~DEF_SET_BIT0

/*  OPA0CR1, 0xFF71H, XSFR  */
#define SET_OP0NSEL3()    OPA0CR1 |= DEF_SET_BIT7     // OPA0CR1^7;
#define CLR_OP0NSEL3()    OPA0CR1 &=~DEF_SET_BIT7
#define SET_OP0NSEL2()    OPA0CR1 |= DEF_SET_BIT6     // OPA0CR1^6;
#define CLR_OP0NSEL2()    OPA0CR1 &=~DEF_SET_BIT6
#define SET_OP0NSEL1()    OPA0CR1 |= DEF_SET_BIT5     // OPA0CR1^5;
#define CLR_OP0NSEL1()    OPA0CR1 &=~DEF_SET_BIT5
#define SET_OP0NSEL0()    OPA0CR1 |= DEF_SET_BIT4     // OPA0CR1^4;
#define CLR_OP0NSEL0()    OPA0CR1 &=~DEF_SET_BIT4
#define SET_OP0PSEL3()    OPA0CR1 |= DEF_SET_BIT3     // OPA0CR1^3;
#define CLR_OP0PSEL3()    OPA0CR1 &=~DEF_SET_BIT3
#define SET_OP0PSEL2()    OPA0CR1 |= DEF_SET_BIT2     // OPA0CR1^2;
#define CLR_OP0PSEL2()    OPA0CR1 &=~DEF_SET_BIT2
#define SET_OP0PSEL1()    OPA0CR1 |= DEF_SET_BIT1     // OPA0CR1^1;
#define CLR_OP0PSEL1()    OPA0CR1 &=~DEF_SET_BIT1
#define SET_OP0PSEL0()    OPA0CR1 |= DEF_SET_BIT0     // OPA0CR1^0;
#define CLR_OP0PSEL0()    OPA0CR1 &=~DEF_SET_BIT0

#endif
