/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   EEPROM
;  *            ļ128 Byteȫռ
;  *                     ֽ&ȫռд
;  *                     ֽڶȡ
******************************************************************************/

#include "EEPROM.h"

/************************************************
;  *    @            : EEPROM_Page_Erase
;  *    @˵              : EEPROMȫռҳ 128 Byte
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void EEPROM_Page_Erase(void)
{
    DISABLE_GIE();
    SET_INFOS();             //лEEPROM-LIKE
    SET_IAPEN();
    SET_IAPEN();             //IAP(дЧ)
    SET_PAGEERS();
    SET_PAGEERS();           //ҳģʽ(дЧ)
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPSTR();
    IAPADH = 0;
    IAPADL = 0;
    IAPDB = 0;
    IAPADL = 0;
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG0();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG1();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG2();
    while (IAPCR & 0x80);
    CLR_INFOS();             //лFLASH
    ENABLE_GIE();
}

/************************************************
;  *    @            : EEPROM_Byte_Write
;  *    @˵              : EEPROMдģʽ
;  *    @          : addrַ 00x7F,value 
;  *    @ز          :
;  ***********************************************/
void EEPROM_Byte_Write(uint8_t addr,uint8_t value)
{
    DISABLE_GIE();
    SET_INFOS();             //лEEPROM-LIKE
    SET_IAPEN();
    SET_IAPEN();             //IAP(дЧ)
    SET_BYTEWR();
    SET_BYTEWR();            //дģʽ(дЧ)
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPSTR();
    IAPADH = 0;
    IAPADL = addr;
    IAPDB = value;
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG0();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG1();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG2();
    while (IAPCR & 0x80);
    CLR_INFOS();             //лFLASH
    ENABLE_GIE();
}

/************************************************
;  *    @            : EEPROM_Write_Buff
;  *    @˵              : EEPROMȫռдֵ 00x7F
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void EEPROM_Write_Buff(void)
{
    uint8_t cnt;
    uint8_t addr = 0;
    DISABLE_GIE();
    for(cnt=0;cnt<128;cnt++)
    {
        EEPROM_Byte_Write(addr,cnt);
        addr++;
    }
    ENABLE_GIE();
}

/************************************************
;  *    @            : EEPROM_Byte_Read
;  *    @˵              : EEPROMֽڶ
;  *    @          : addrַ 00x7F
;  *    @ز          :
;  ***********************************************/
uint16_t EEPROM_Byte_Read(uint16_t addr)
{
    uint8_t Value;
    DISABLE_GIE();
    SET_INFOS();
    Value= *(uint8_t code *)addr;
    CLR_INFOS();             //лFLASH
    ENABLE_GIE();
    return Value;
}

