/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                                                            
******************************************************************************/

#include "w25qxx.h"
#include "SPI.h"

//4KbytesΪһSector
//16Ϊ1Block
//W25Q128
//Ϊ16Mֽ,128Block,4096Sector
/************************************************
;  *     @       : W25QXX_Init
;  *     @˵         : ʼflash
;  *     @     :
;  *     @ز
;  ***********************************************/
void W25QXX_Init(void)
{
    CS = 1;           //SPI FLASHѡ
    SPI_Init();         //ʼSPI
}

/************************************************
;  *     @         : W25QXX_ReadSR
;  *     @˵           : ȡW25QXX״̬Ĵ
;  *     @       :
;  *     @ز       : BIT7  6   5   4   3   2   1   0
                           SPR   RV  TB BP2 BP1 BP0 WEL BUSY
                           SPR:Ĭ0,״̬Ĵλ,WPʹ
                           TB,BP2,BP1,BP0:FLASHд
                           WEL:дʹ
                           BUSY:æλ(1,æ;0,)
                           Ĭ:0x00
;  ***********************************************/
uint8_t W25QXX_ReadSR(void)
{
    uint8_t byte = 0;
    CS = 0;                                    //ʹ
    SPI1_ReadWriteByte(W25X_ReadStatusReg);      //Ͷȡ״̬Ĵ
    byte = SPI1_ReadWriteByte(0Xff);             //ȡһֽ
    CS = 1;                                    //ȡƬѡ
    return byte;
}

/************************************************
;  *    @            : W25QXX_Write_SR
;  *    @˵              : дW25QXX״̬Ĵ
;  *    @          : ֻSPR,TB,BP2,BP1,BP0
                            (bit 7,5,4,3,2)д!!!
;  *    @ز          :
;  ***********************************************/
void W25QXX_Write_SR(uint8_t sr)
{
    CS = 0;                                    //ʹ
    SPI1_ReadWriteByte(W25X_WriteStatusReg);     //дȡ״̬Ĵ
    SPI1_ReadWriteByte(sr);                      //дһֽ
    CS = 1;                                    //ȡƬѡ
}

/************************************************
;  *    @            : W25QXX_Write_Enable
;  *    @˵              : W25QXXдʹ  WELλ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_Write_Enable(void)
{
    CS = 0;                                    //ʹ
    SPI1_ReadWriteByte(W25X_WriteEnable);        //дʹ
    CS = 1;                                    //ȡƬѡ
}

/************************************************
;  *    @            : W25QXX_Write_Disable
;  *    @˵              : W25QXXдֹ  WEL
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_Write_Disable(void)
{
    CS = 0;                                    //ʹ
    SPI1_ReadWriteByte(W25X_WriteDisable);       //дָֹ
    CS = 1;                                    //ȡƬѡ
}

/************************************************
;  *    @            : W25QXX_ReadID
;  *    @˵              : ȡоƬID
;  *    @          :
;  *    @ز          :0XEF13,ʾоƬͺΪW25Q80
                           0XEF14,ʾоƬͺΪW25Q16
                           0XEF15,ʾоƬͺΪW25Q32
                           0XEF16,ʾоƬͺΪW25Q64
                           0XEF17,ʾоƬͺΪW25Q128
;  ***********************************************/
uint16_t W25QXX_ReadID(void)
{
    uint16_t temp = 0;
    CS = 0;
    SPI1_ReadWriteByte(0x90);          //ͶȡID
    SPI1_ReadWriteByte(0x00);
    SPI1_ReadWriteByte(0x00);
    SPI1_ReadWriteByte(0x00);
    temp |= SPI1_ReadWriteByte(0xFF) << 8;
    temp |= SPI1_ReadWriteByte(0xFF);
    CS = 1;
    return temp;
}

/************************************************
;  *    @            : W25QXX_Read
;  *    @˵              : ȡSPI FLASH
;  *    @          : pBuffer:ݴ洢
                            ReadAddr:ʼȡĵַ(24bit)
                            NumByteToRead:Ҫȡֽ(65535)
;  *    @ز          :
;  ***********************************************/
void W25QXX_Read(uint8_t *pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead)
{
    uint16_t i;
    CS = 0;                                              //ʹ
    SPI1_ReadWriteByte(W25X_ReadData);                     //Ͷȡ
    SPI1_ReadWriteByte((uint8_t)((ReadAddr) >> 16));       //24bitַ
    SPI1_ReadWriteByte((uint8_t)((ReadAddr) >> 8));
    SPI1_ReadWriteByte((uint8_t)ReadAddr);
    for (i = 0; i < NumByteToRead; i++)
    {
        pBuffer[i] = SPI1_ReadWriteByte(0XFF);             //ѭ
    }
    CS = 1;
}

/************************************************
;  *    @            : W25QXX_Write_Page
;  *    @˵              : дҳ
;  *    @          : pBuffer:ݴ洢
                            WriteAddr:ʼдĵַ(24bit)
                            NumByteToWrite:Ҫдֽ(256),
                            Ӧóҳʣֽ!!!
;  *    @ز          :
;  ***********************************************/
void W25QXX_Write_Page(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite)
{
    uint16_t i;
    W25QXX_Write_Enable();                                 //SET WEL
    CS = 0;                    //ʹ
    SPI1_ReadWriteByte(W25X_PageProgram);                  //дҳ
    SPI1_ReadWriteByte((uint8_t)((WriteAddr) >> 16));      //24bitַ
    SPI1_ReadWriteByte((uint8_t)((WriteAddr) >> 8));
    SPI1_ReadWriteByte((uint8_t)WriteAddr);
    for (i = 0; i < NumByteToWrite; i++)
        SPI1_ReadWriteByte(pBuffer[i]);                    //ѭд
    CS = 1;                                              //ȡƬѡ
    W25QXX_Wait_Busy();                                    //ȴд
}

/************************************************
;  *    @            : W25QXX_Write_NoCheck
;  *    @˵              : ޼дSPI FLASH
                            ȷдĵַΧڵȫΪ0XFF,
                            ڷ0XFFдݽʧ!
                            Զҳܣ
                            ַָʼдָȵ,ҪȷַԽ!
;  *    @          : 
                            pBuffer:ݴ洢
                            WriteAddr:ʼдĵַ(24bit)
                            NumByteToWrite:Ҫдֽ(65535)
;  *    @ز          :
;  ***********************************************/
void W25QXX_Write_NoCheck(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite)
{
    uint16_t pageremain;
    pageremain = 256 - WriteAddr % 256;          //ҳʣֽ
    if (NumByteToWrite <= pageremain)
    pageremain = NumByteToWrite;                 //256ֽ
    while (1)
    {
        W25QXX_Write_Page(pBuffer, WriteAddr, pageremain);
        if (NumByteToWrite == pageremain)
            break;                               //д
        else                                     //NumByteToWrite>pageremain
        {
            pBuffer += pageremain;
            WriteAddr += pageremain;
            NumByteToWrite -= pageremain;        //ȥѾд˵ֽ
            if (NumByteToWrite > 256)
                pageremain = 256;                //һοд256ֽ
            else
                pageremain = NumByteToWrite;     //256ֽ
        }
    }
}

/************************************************
;  *    @            : W25QXX_Erase_Chip
;  *    @˵              : оƬ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_Erase_Chip(void)
{
    W25QXX_Write_Enable();                       //SET WEL
    W25QXX_Wait_Busy();
    CS = 0;                                    //ʹ
    SPI1_ReadWriteByte(W25X_ChipErase);          //Ƭ
    CS = 1;                                    //ȡƬѡ
    W25QXX_Wait_Busy();                          //ȴоƬ
}

/************************************************
;  *    @            : W25QXX_Erase_Sector
;  *    @˵              : һ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_Erase_Sector(uint32_t Dst_Addr)
{
//falsh,
// printf("fe:%x\r\n", Dst_Addr);
    Dst_Addr *= 4096;
    W25QXX_Write_Enable();                                 //SET WEL
    W25QXX_Wait_Busy();
    CS = 0;                                              //ʹ
    SPI1_ReadWriteByte(W25X_SectorErase);                  //ָ
    SPI1_ReadWriteByte((uint8_t)((Dst_Addr) >> 16));       //24bitַ
    SPI1_ReadWriteByte((uint8_t)((Dst_Addr) >> 8));
    SPI1_ReadWriteByte((uint8_t)Dst_Addr);
    CS = 1;                                              //ȡƬѡ
    W25QXX_Wait_Busy();                                    //ȴ
}

/************************************************
;  *    @            : W25QXX_Wait_Busy
;  *    @˵              : ȴ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_Wait_Busy(void)
{
    while ((W25QXX_ReadSR() & 0x01) == 0x01);         // ȴBUSYλ
}

/************************************************
;  *    @            : W25QXX_PowerDown
;  *    @˵              : ģʽ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_PowerDown(void)
{
    CS = 0;                               //ʹ
    SPI1_ReadWriteByte(W25X_PowerDown);     //͵
    CS = 1;                               //ȡƬѡ
    NOP10();
      NOP10();                                //ȴTPD
}

/************************************************
;  *    @            : W25QXX_WAKEUP
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void W25QXX_WAKEUP(void)
{
    CS = 0;                                         //ʹ
    SPI1_ReadWriteByte(W25X_ReleasePowerDown);        //  send W25X_PowerDown command 0xAB
    CS = 1;                                         //ȡƬѡ
    NOP10();
    NOP10();                                          //ȴTRES1
}
